# Fg42 - Emacs Editor for advance users
#
# Copyright (c) 2010-2024 Sameer Rahmani <lxsameer@gnu.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
{ lib, stdenv, emacs29, callPackage,  writeShellApplication, noether
, emacsParams ? {},
  fg42Params ? {}
} :
let
  lemacs = emacs29.override ({
    withTreeSitter = true;
  } // emacsParams);

  elispDepsFile = ../lisp/fg42/deps.el;

  elispPkgs = callPackage ./deps.nix {
    inherit elispDepsFile;
  };

  ourPackages = {
    noether-mode = noether;
  };

  fg42 = callPackage ./fg42.nix ({
    inherit elispPkgs ourPackages;
    srcDir = ../.;
    emacs = lemacs;

  } // fg42Params);

  run-test-wm = writeShellApplication {
    name = "run-test-wm";
    runtimeInputs = [ fg42 ];

    text = ''
    	DISPLAY=:1 ${fg42}/bin/fg42-wm
    '';
  };
in { inherit fg42 run-test-wm; }
